import java.nio.ByteBuffer;

import org.jpab.Callback;
import org.jpab.Device;
import org.jpab.PortAudio;
import org.jpab.PortAudioException;
import org.jpab.Stream;
import org.jpab.StreamConfiguration;
import org.jpab.StreamConfiguration.Mode;
import org.jpab.StreamConfiguration.SampleFormat;



public class HelloPortAudio implements Callback,Runnable{
	
	private float min = 1000000,max = 0;
	
	public static void main(String[] args) {
		
		HelloPortAudio hpa = new HelloPortAudio();
		
		try {
			PortAudio.initialize();
			for(Device d : PortAudio.getDevices()) System.out.println(d);//print devices
			
			Device d = PortAudio.getDevices().get(1);//choose Microphone (Realtek High Definition Audio)
			
			if(d.getMaxInputChannels() > 0){
				StreamConfiguration sc = new StreamConfiguration();
				sc.setInputDevice(d);
				sc.setInputFormat(SampleFormat.SIGNED_INTEGER_16);
				sc.setMode(Mode.INPUT_ONLY);
				sc.setSampleRate(d.getDefaultSampleRate());
				sc.setInputChannels(d.getMaxInputChannels());
				sc.setInputLatency(d.getDefaultLowInputLatency());
				
				PortAudio.createStream(sc, hpa, new Runnable() {
					public void run() {
						try {
							PortAudio.terminate();
						} catch (PortAudioException ignore) { ignore.printStackTrace(); }
					}
				}).start();
			}
			//*/
			
		} catch (PortAudioException e) {
			e.printStackTrace();
		}
	}

	@Override
	public State callback(ByteBuffer in, ByteBuffer out) {
		System.out.println("in bytes:" + in.capacity() + " min: " + min + " max: " + max);
		for (int i = 0; i < in.capacity(); i++) {
			float v = in.getFloat(i);
			if(v > max) max = v;
			if(v < min) min = v;
		}
		return State.RUNNING;
	}
	
	public HelloPortAudio(){
		this.run();
	}

	@Override
	public void run() {
		System.out.println("running");	
	}

}
