import java.nio.ByteBuffer;

import org.jpab.Callback;
import org.jpab.Device;
import org.jpab.PortAudio;
import org.jpab.PortAudioException;
import org.jpab.Stream;
import org.jpab.StreamConfiguration;
import org.jpab.StreamConfiguration.Mode;
import org.jpab.StreamConfiguration.SampleFormat;


import processing.core.PApplet;


public class PortAudioPlot extends PApplet implements Callback {
	
	float min = 1000000,max = 0;
	
	public void setup(){
		try {
			PortAudio.initialize();
			for(Device d : PortAudio.getDevices()) println(d);
			
			Device d = PortAudio.getDevices().get(1);// Microphone (Realtek High Definition Audio)
			if(d.getMaxInputChannels() > 0){
				println(d.getName());
				StreamConfiguration sc = new StreamConfiguration();
				sc.setInputDevice(d);
				sc.setInputFormat(SampleFormat.SIGNED_INTEGER_16);
				sc.setMode(Mode.INPUT_ONLY);
				sc.setSampleRate(44100);
				sc.setInputChannels(d.getMaxInputChannels());
				PortAudio.createStream(sc, this, new Runnable() {
					public void run() {
						try {
							PortAudio.terminate();
						} catch (PortAudioException ignore) { ignore.printStackTrace(); }
					}
				}).start();
			}
		} catch (PortAudioException e) {
			e.printStackTrace();
		}
	}
	public void draw(){
		if(keyPressed && key == 's') saveFrame(dataPath("frame-####.jpg"));
	}
	public void stop(){
		try {
			PortAudio.terminate();
		} catch (PortAudioException e) {
			e.printStackTrace();
		}
		super.stop();
	}
	
	public static void main(String[] args) {
		PApplet.main(PortAudioPlot.class.getSimpleName());
	}
	@Override
	public State callback(ByteBuffer in, ByteBuffer out) {
		int size = in.capacity();
		println("in size: " + size + " min: " + min + " max: " + max);
		background(255);
		beginShape(LINES);
		for (int i = 0; i < size; i++) {
			float v = in.getFloat(i);
			if(!Float.isNaN(v) || v != Float.POSITIVE_INFINITY || v != Float.NEGATIVE_INFINITY){
				float x = map(i,0,size,0,width);
				float y = (height * .5f) + (v * .5f);
				if(v < min) min = v;
				if(v > max) max = v;
				vertex(x,y);
			}
		}
		endShape();
		return State.ABORTED;
	}

}
