import java.io.IOException;
import java.nio.ByteBuffer;

import org.jpab.Callback;
import org.jpab.Device;
import org.jpab.PortAudio;
import org.jpab.PortAudioException;
import org.jpab.Stream;
import org.jpab.StreamConfiguration;
import org.jpab.StreamConfiguration.Mode;
import org.jpab.StreamConfiguration.SampleFormat;

import processing.core.PApplet;
import processing.core.PConstants;


public class PortAudioTest extends PApplet implements Callback {
	
	PortAudio pa;
	
	int[] c = {color(192,0,0),color(0,192,0),color(0,0,192),
			   color(192,192,0),color(0,192,192),color(192,0,192),
			   color(0),color(192),color(127)};
	
	public void setup(){
		size(800,800);
		
		try {
			PortAudio.initialize();
			//for(Device d : PortAudio.getDevices()) {
			//for (int j = 0; j < PortAudio.getDevices().size(); j++) {
			for (int j = 1; j < 2; j++) {
				Device d = PortAudio.getDevices().get(j);
				if(d.getMaxInputChannels() > 0){
					println(j+":"+d.getName());
					StreamConfiguration sc = new StreamConfiguration();
					sc.setInputDevice(d);// Microphone (Realtek High Definition Audio)
					sc.setInputFormat(SampleFormat.SIGNED_INTEGER_16);
					sc.setMode(Mode.INPUT_ONLY);
					sc.setSampleRate(44100);
					sc.setInputChannels(d.getMaxInputChannels());
					
					Stream s = PortAudio.createStream(sc, new PACallback(this, j*80,c[j]), new Runnable() {
						public void run() {
							try {
								PortAudio.terminate();
							} catch (PortAudioException ignore) { ignore.printStackTrace(); }
						}
					});
					s.start();
				}
			}
			
			/*
			Device d = PortAudio.getDevices().get(4);
			println("opening: " + d.getName());
			if(d.getMaxInputChannels() > 0){
				StreamConfiguration sc = new StreamConfiguration();
				sc.setInputDevice(d);// Microphone (Realtek High Definition Audio)
				sc.setInputFormat(SampleFormat.UNSIGNED_INTEGER_8);
				sc.setMode(Mode.INPUT_ONLY);
				sc.setSampleRate(d.getDefaultSampleRate());
				sc.setInputChannels(d.getMaxInputChannels());
				sc.setInputLatency(d.getDefaultLowInputLatency());
				
				Stream s = PortAudio.createStream(sc, this, new Runnable() {
					public void run() {
						try {
							PortAudio.terminate();
						} catch (PortAudioException ignore) { ignore.printStackTrace(); }
					}
				});
				s.start();
			}
			//*/
			
		} catch (PortAudioException e) {
			e.printStackTrace();
		}
		
	}
	
	public void draw(){
		background(255);
	}
	
	public static void main(String[] args) {
		PApplet.main(PortAudioTest.class.getSimpleName());
	}
	
	public class PACallback implements Callback,PConstants{
		
		PApplet context;
		int offset = 0;
		int color;
		float min = 1000000,max = 0;
		
		PACallback(PApplet p5,int voff,int c){
			context = p5;
			offset = voff;
			color = c;
		}
		
		@Override
		public State callback(ByteBuffer arg0, ByteBuffer arg1) {
			System.out.println(arg0.capacity() + " min: "+min+" max:"+max);
			context.pushStyle();
			context.stroke(color);
			context.beginShape(LINES);
			for(int i = 0 ; i < arg0.capacity(); i++){
				float v = arg0.getFloat(i);
				//float v = PApplet.map(arg0.getFloat(i), -2.4989746E38f, -2.4989746E38f, 0, 100);
				if (v > max) max = v;
				if (v < min) min = v;
				context.vertex(i, v+offset);
				context.vertex(i, offset*2);
			}
			context.endShape();
			context.popStyle();
			return State.COMPLETE;
		}
		
		
	}

	@Override
	public State callback(ByteBuffer in, ByteBuffer out) {
		println("left:"+ in.capacity());
		beginShape(LINES);
		for (int i = 0; i < in.capacity(); i++) {
			int v = in.getInt(i);
//			float v = left.getFloat(i);
			if(i < 10) println(i+":"+v);
			vertex(i,v);
			vertex(i,height);
		}
		endShape();
		return null;
	}

}
